// Begin License:
// Copyright (C) 2006-2014 Tobias Sargeant (tobias.sargeant@gmail.com).
// All rights reserved.
//
// This file is part of the Carve CSG Library (http://carve-csg.com/)
//
// This file may be used under the terms of either the GNU General
// Public License version 2 or 3 (at your option) as published by the
// Free Software Foundation and appearing in the files LICENSE.GPL2
// and LICENSE.GPL3 included in the packaging of this file.
//
// This file is provided "AS IS" with NO WARRANTY OF ANY KIND,
// INCLUDING THE WARRANTIES OF DESIGN, MERCHANTABILITY AND FITNESS FOR
// A PARTICULAR PURPOSE.
// End:


#pragma once

#include <carve/carve.hpp>

#include <carve/poly.hpp>
#include <carve/matrix.hpp>

#ifdef WIN32
#undef rad1
#undef rad2
#endif

carve::mesh::MeshSet<3> *makeCube(
    const carve::math::Matrix &transform = carve::math::Matrix());

carve::mesh::MeshSet<3> *makeSubdividedCube(
    int sub_x = 3,
    int sub_y = 3,
    int sub_z = 3,
    bool (*inc)(int, int, int) = NULL,
    const carve::math::Matrix &transform = carve::math::Matrix());

carve::mesh::MeshSet<3> *makeDoubleCube(
    const carve::math::Matrix &transform = carve::math::Matrix());

carve::mesh::MeshSet<3> *makeTorus(
    int slices, 
    int rings, 
    double rad1, 
    double rad2, 
    const carve::math::Matrix &transform = carve::math::Matrix());

carve::mesh::MeshSet<3> *makeCylinder(
    int slices, 
    double rad, 
    double height, 
    const carve::math::Matrix &transform = carve::math::Matrix());

carve::mesh::MeshSet<3> *makeCone(
    int slices, 
    double rad, 
    double height, 
    const carve::math::Matrix &transform = carve::math::Matrix());
